#ifndef __BOX__
#define __BOX__

#include <iostream.h>
#include "interval.h"


class box
{
public:
	box ();
	box (int, bool);
	box (box&);
	~box ();
	interval& operator[] (int) const ;
	void operator= (box);
	void Resize (int);
public: //protected:
	interval* data;
	bool isEmpty;
//public:
	int dim;
    box* next;   //pour faire des listes de paves dans qminimax

friend double       Angle       (box&v,box&); // Il faut des vecteurs de dim 2
friend int			AxePrincipal(box&);
friend int			AxePrincipal(box&,box&);
friend void			Bisect		(box&, box&,box&);
friend void         BisectRand  (box&, box&,box&);
friend void			Bisect		(box&, box&,box&,box&);
friend void			BisectAlong	(box&, box&,box&,int);
friend void         BisectHere  (box& ,box&,box&,int,double);
friend box			Center		(const box&);
friend void			CheckRange	(box&,box&);
friend interval     Determinant (box&, box&);
friend bool		    Disjoint	(const box&,const box&);
friend double         Eloignement (box&,box&);
friend double         Eloignement2(box&,box&);
friend double         EloignementRelatif2(box&,box&);
friend iboolean	    In			(box&,box&);
friend box			Inf 		(box&);
friend box			Inflate 	(box&,double);
friend box			Inter 		(const box&,const box&);
//friend void         Inter1      (box&,box&,const box&,const box&,const box&);
friend interval     Norm        (box&);
friend void         Phi0        (box&,box*);             //0-intersection (voir qminimax)
friend void         Phi1        (box&,box&,box*);       //1-intersection (voir qminimax)
friend void         Phi2        (box&,box&,box&,box*);  //2-intersection
friend interval     ProduitScalaire(box&,box&);
friend bool         Prop        (box&,box&);
friend bool			Subset		(box&,box&);
friend bool			Subset		(box&,box&,double);
friend void         Sucre       (box&,box&);
friend box			Sup 		(box&);
friend box			Union		(box&,box&);
friend double         Volume      (box&);
friend double			Width		(box&);
friend double			Width		(box&,box&);
friend box          Zeros       (int);

friend box	operator+(const box&,const box&);
friend box	operator-(const box&);
friend box	operator-(const box&,const box&);
friend box	operator*(const interval&,const box&);
friend box	operator*(const box&,const interval&);
friend ostream& operator<<(ostream&, const box&);
};

#endif
